close all
clear all
clc

%% Paths where the original data, the edges got from pdollar algorithm
nmsedgpath =  '..\image\GoPro\edge\GoPro_Right_Red\GX010103\origin';
imgpath = '..\image\GoPro\image\GoPro_Right_Red\GX010103\origin';
writepath = '.\Data\GoPro\GoPro_Right_Red\GX010103\Workshop_Images';

startFrame = 1998;
endFrame = 2018; % set to 1998 for efficiency. original value is 2018;
%% Size of the pictures, not necessarily needed
Width = 2704;
Height = 2028;

%% Video
% videoname  = ['.\Data\GoPro\GoPro_Left_White\GX010467\Workshop_Video\EdgeExtraction_Rec_GX010467'];
% writerObj = VideoWriter(videoname);
% Total_time  = 100; % total time of video in seconds
% framerate = 2;
% writerObj.FrameRate = framerate;
% open(writerObj);
% 
% f1 = figure('units','normalized','outerposition',[0 0 1 1]);
%  tic
for i = startFrame:endFrame
 tic  
%% Read in a frame from the original video data
    fileName = sprintf('%d',i);
    fileName = strcat('im_',fileName);
    Iorigin = imread([imgpath '\' fileName,'.png']);
    frames = Iorigin;
  
%% Convert to black and white image
    frames = rgb2gray(frames);
    framesBW = imbinarize(frames, 0.52); %black and white

%% Parameters for mophorlogical processing
    se = strel('square',13);
    framesBW_DI = imdilate(framesBW, se); %dilate the bw mask

%% Read in frames from the edges got from pdollar algorithm with nms=0 and nms=1, respectively
    frameNmsEdge =  imread(strcat(nmsedgpath,'\',  'im_', num2str(i), '.png'));
    for w = 1:Width
        for h = 1:Height
            if framesBW_DI(h,w) < 1
                frameNmsEdge(h,w) = 255;
            end
        end
    end

 %% Morphology to sharpen the edge
     se2 = strel('square',2);

     
%%%% NMS = 1  
     frameNmsEdge = imerode(frameNmsEdge,se2);
     frameNmsEdge = imerode(frameNmsEdge,se2);
     frameNmsEdge = imdilate(frameNmsEdge,se2);

%%%% Strenthen the edge
    for w=1:Width
        for h=1:Height
            if frameNmsEdge(h,w) < 240
                frameNmsEdge(h,w) = frameNmsEdge(h,w)*0.95;
            end
        end
    end
    
%% use Canny method to extract edges
%     1. canny_v0 is canny with a Gaussian filter
%     2. edge(frameEdge,'Canny',0.1) is from MATLAB

%% Edges from pdollar with NMS = 1
    se3 = strel('square',3);
    testnmsEdge = frameNmsEdge;
    testnmsEdge = imbinarize(testnmsEdge, 0.6);
    testnmsEdge = imcomplement(testnmsEdge);

      
      
%%%% Boundaries extraction
    [B_1, L_1, N_1, A_1] = bwboundaries(testnmsEdge);
    nms_1_Struct(i).coor = B_1;   % Row and column coordinates of boundary pixels
    nms_1_Struct(i).label = L_1;   % Label matrix
    nms_1_Struct(i).num = N_1;   % Number of objects found
    nms_1_Struct(i).adj = A_1;     % Parent-child dependencies between boundaries and holes
%% Make a copy of the Iorigin, 'I' here is capital 'i'
    Iorigincp = Iorigin;

%% Show the edges


    colors=['b' 'g' 'r' 'c' 'm' 'y'];
     
    
    %%
    boi_Num = 1; % 1 more than wanted to make sure passing the enclosure check 

    %% Exclude those short boundaries
    tempCoor = nms_1_Struct(i).coor;
    B_Coor = [];
    B_Size = [];
    for loop = 1:1:size(tempCoor,1)
        B_Coor = tempCoor{loop,1};
        B_Size(loop) = size(B_Coor,1);
    end


    [totalV, totalIndex] = sort(B_Size, 'descend');  % Rearrange the size in descending order
    
    %% Boundaries of interest (BOI), we only choose two of them
    targetIndex = totalIndex(1,1:boi_Num);
    
    for k=1:length(targetIndex)
      boundary_1 = B_1{targetIndex(1, k)};
      cidx = mod(k,length(colors))+1;
      plot(boundary_1(:,2), boundary_1(:,1),...
           colors(cidx),'LineWidth',2);
    end
    
    nms_1_Struct(i).tarIndex = targetIndex; 

    
%% Video
%     F = imcapture(f1);
%     writeVideo(writerObj,F);
end
%  close(writerObj);   
